﻿using System;

namespace DpiScaling
{
    /// <summary>
    /// https://docs.microsoft.com/en-us/office/client-developer/ddpi/handle-high-dpi-and-dpi-scaling-in-your-office-solution
    /// </summary>
    class DPIContextBlock : IDisposable
    {
        private DPIHelper.DPI_AWARENESS_CONTEXT resetContext;
        private bool disposed = false;

        public DPIContextBlock(DPIHelper.DPI_AWARENESS_CONTEXT contextSwitchTo)
        {
            resetContext = DPIHelper.SetThreadDpiAwareness(contextSwitchTo);
        }

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }

        protected virtual void Dispose(bool disposing)
        {
            if (!disposed)
            {
                if (disposing)
                {
                    DPIHelper.SetThreadDpiAwareness(resetContext);
                }
            }
            disposed = true;
        }
    }
}
