﻿using System;

namespace Logging
{
    public class LogRecord : EventArgs
    {
        public string Time { get; private set; }
        public string Sender { get; private set; }
        public string Message { get; private set; }
        public LogRecord(string sender, string message)
        {
            Time = DateTime.Now.ToString("hh:mm:ss.fff tt");
            Sender = (sender == null) ? "unknown" : sender;
            Message = message;
        }
        public override string ToString()
        {
            return string.Format("{0} {1} {2}", Time, Sender, Message);
        }
    }
}
