﻿using DpiScaling;
using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace adx_ol_cs_PaneLocation
{
    public partial class FormLog : MyDpiAwareForm
    {
        public FormLog() : base(scaleMe: true)
        {
            InitializeComponent();
            userControlLog1.theParent = this;
        }

        private void FormLog_Load(object sender, EventArgs e)
        {
            this.userControlLog1.logList.Items.Clear();
            List<Logging.LogRecord> logRecords = Logging.Log.GetRecords();
            foreach (var item in logRecords)
            {
                this.userControlLog1.logList.Items.Add(item.ToString());
            }
        }

        internal override void FixDpi()
        {
            if (this.elementHost1.Child != null
                && this.elementHost1.Child is UserControlLog)
            {
                (this.elementHost1.Child as UserControlLog).FixDpi(this.DPI);
            }
        }
        protected override void WndProc(ref Message m)
        {
            switch (m.Msg)
            {
                case Win32Api.WM_DPICHANGED:   // https://docs.microsoft.com/en-us/windows/win32/hidpi/wm-dpichanged
                    Win32Api.RECT newDisplayRect = (Win32Api.RECT)Marshal.PtrToStructure(m.LParam, typeof(Win32Api.RECT));

                    Win32Api.RECT newRect = (Win32Api.RECT)Marshal.PtrToStructure(m.LParam, typeof(Win32Api.RECT));
                    // Set the form size and location in one step. Using other bounds(e.g.changing Size and Location separately) creates a loop of WM_DPIChanged messages
                    this.SetBounds(newRect.Left, newRect.Top, newRect.Right - newRect.Left, newRect.Bottom - newRect.Top);

                    int newDpi = (int)(m.WParam.ToInt64() & 0x7FFF);
                    this.DPI = newDpi;

                    break;
                default:
                    base.WndProc(ref m);
                    break;
            }
        }
    }
}
