﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Interop;
using System.Windows.Media;

namespace adx_ol_cs_PaneLocation
{
    /// <summary>
    /// Interaction logic for UserControlLog.xaml
    /// </summary>
    public partial class UserControlLog : UserControl
    {
        public UserControlLog()
        {
            InitializeComponent();
        }

        public System.Windows.Forms.Form theParent = null;

        private void copyToClipboard_Click(object sender, RoutedEventArgs e)
        {
            string result = string.Empty;
            foreach (var item in this.logList.Items)
                result = result + item + "\n";
            
            Clipboard.SetText(result);
            MessageBox.Show("Log records are copied to the Clipboard.");

        }
        private void close_Click(object sender, RoutedEventArgs e)
        {
            if (theParent != null) theParent.Close();
        }
        bool isLoaded = false;
        int dpiToUse = 0;
        internal void FixDpi(int dpi)
        {
            if (isLoaded)
            {
                Logging.Log.Add("FixDpi", "isLoaded" + " dpi=" + dpi.ToString());
                ApplyScaleTransform(dpi);
            }
            else
            {
                Logging.Log.Add("FixDpi", "!isLoaded" + " dpi=" + dpi.ToString());
                dpiToUse = dpi;
            }
        }
        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            isLoaded = true;
            if (dpiToUse != 0)
            {
                Logging.Log.Add("UserControl_Loaded", " dpiToUse=" + dpiToUse.ToString());
                ApplyScaleTransform(dpiToUse);
            }
        }
        void ApplyScaleTransform(int dpi)
        {
            var source = (HwndSource)PresentationSource.FromVisual(this);
            if (source == null) return;

            Logging.Log.Add("ApplyScaleTransform", "dpi=" + dpi.ToString());
            var wpfDpi = 96 * source.CompositionTarget.TransformToDevice.M11;
            var scaleFactor = dpi / wpfDpi;
            Logging.Log.Add("ApplyScaleTransform", "scaleFactor=" + scaleFactor.ToString());

            var scaleTransform = Math.Abs(scaleFactor - 1.0) < 0.001 ? null : new ScaleTransform(scaleFactor, scaleFactor);
            this.SetValue(FrameworkElement.LayoutTransformProperty, scaleTransform);
        }
    }
}
