﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Media;
using System.Windows.Interop;

namespace adx_ol_cs_PaneLocation
{
    /// <summary>
    /// Interaction logic for UserControl1.xaml
    /// </summary>
    public partial class UserControlPaneInfo : UserControl
    {
        public string Info { get
            {
                return this.TextBlock.Text;
            }
            internal set
            {
                this.TextBlock.Text = value;
            }
        }

        public UserControlPaneInfo()
        {
            InitializeComponent();
        }

        public void PopulateListAndSelectItem(string[] items, string layout)
        {
            this.list.Items.Clear();
            int index = -1;
            for (int i=0; i< items.Length; i++)
            {
                string item = items[i];
                this.list.Items.Add(item);
                if (item == layout)
                    index = i;
            }
            list.SelectedIndex = index;
        }

        bool isLoaded = false;
        int dpiToUse = 0;
        internal void FixDpi(int dpi)
        {
            if (isLoaded)
            {
                ApplyScaleTransform(dpi);
            }
            else
            {
                dpiToUse = dpi;
            }
        }
        void ApplyScaleTransform(int dpi)
        {
            var source = (HwndSource)PresentationSource.FromVisual(this);
            if (source == null) return;

            //System.Diagnostics.Debug.WriteLine("!!! ApplyScaleTransform. dpi=" + dpi.ToString());
            var wpfDpi = 96 * source.CompositionTarget.TransformToDevice.M11;
            var scaleFactor = dpi / wpfDpi;
            //System.Diagnostics.Debug.WriteLine("!!! ApplyScaleTransform. scaleFactor=" + scaleFactor.ToString());

            var scaleTransform = Math.Abs(scaleFactor - 1.0) < 0.001 ? null : new ScaleTransform(scaleFactor, scaleFactor);
            this.SetValue(FrameworkElement.LayoutTransformProperty, scaleTransform);
        }
        private void uc_Loaded(object sender, RoutedEventArgs e)
        {
            isLoaded = true;
            if (dpiToUse != 0)
            {
                ApplyScaleTransform(dpiToUse);
            }
        }
    }
}
